'Oshonsoft USBDemo1.bas, requires the USB_Terminal1.exe installed in a PC.
'25Feb2011

Define CONFIG1L = 0x24
Define CONFIG1H = 0x0c
Define CONFIG2L = 0x38
Define CONFIG2H = 0x00
Define CONFIG3L = 0x00
Define CONFIG3H = 0x83
Define CONFIG4L = 0x80
Define CONFIG4H = 0x00
Define CONFIG5L = 0x0f
Define CONFIG5H = 0xc0
Define CONFIG6L = 0x0f
Define CONFIG6H = 0xe0
Define CONFIG7L = 0x0f
Define CONFIG7H = 0x40

UsbSetVendorId 0x1234
UsbSetProductId 0x1234
UsbSetVersionNumber 0x1122
UsbSetManufacturerString "OshonSoft.com"
UsbSetProductString "Generic USB HID Device"
UsbSetSerialNumberString "1111111111"
UsbOnIoInGosub usbonioin
UsbOnIoOutGosub usbonioout
UsbOnFtInGosub usbonftin
UsbOnFtOutGosub usbonftout


AllDigital

'''Define SIMULATION_WAITMS_VALUE = 1

Define ADC_CLOCK = 3
Define ADC_SAMPLEUS = 50

Define LCD_LINES = 2  'could be 4 lines if required.
Define LCD_CHARS = 16
''
Define LCD_BITS = 4
Define LCD_DREG = PORTB
Define LCD_DBIT = 4

Define LCD_RSREG = PORTC
Define LCD_RSBIT = 0
Define LCD_EREG = PORTB
Define LCD_EBIT = 3
Define LCD_RWREG = PORTB
Define LCD_RWBIT = 2

'LCD ASCII bfr
Dim asc1(4) As Byte

'16Bit Binary to 5 ASCII var
Dim temp1 As Word
Dim binval As Word

'intermediate user buffers.
'easier to use shorter labels.
Dim x As Byte
Dim r1(8) As Byte  'r-eport
Dim f1(8) As Byte  'f-eature

Dim char1 As Byte
Dim char2 As Byte

Dim vadc0 As Word

ADCON0 = 0x01
ADCON1 = 0x0d  'an0 and an1 are Analog

TRISA = 0x3f  'an2,3,4,5 are digital inputs
TRISB = 0
TRISC = 0

PWMon 1, 9  'RC2
PWMon 2, 9  'RC3

Lcdinit
Lcdcmdout LcdClear
Lcdout "USB Demo1."


UsbStart


main:
Adcin 0, vadc0

'set input Volts so that 4.88Vin gives an adc count of 1000
'a 82R/3k6 or 100R/4k3 resistive divider, so 5V reduces to 4.88V
vadc0 = vadc0 * 5
binval = vadc0
Gosub bin2asc
Lcdcmdout LcdLine1Home
Lcdout "V0=", asc1(3), ".", asc1(2), asc1(1), asc1(0), "  "

'preload Feature array, before calling service
f1(0) = "P"
f1(1) = "O"
f1(2) = "R"
f1(3) = "T"
f1(4) = "A"
f1(5) = "="
f1(6) = 0x20  '''''Note the IDE will not allow a space of " "
f1(7) = PORTA And 0xfc  'read PORTA digital inputs
f1(7) = ShiftRight(f1(7), 2)  'move to lower nibble
f1(7) = f1(7) Or 0x30  'make ascii

'preload Report array with ascii value, before calling service
r1(0) = "V"
r1(1) = "0"
r1(2) = "="
r1(3) = asc1(3)
r1(4) = "."
r1(5) = asc1(2)
r1(6) = asc1(1)
r1(7) = asc1(0)


UsbService

Goto main

End                                               

'Report Data from PC to PIC, controlled by PC
'Report data received is stored in UsbIoBuffer array.
usbonioout:

'transfer to local Report buffer
'else I/O values get corrupted

For x = 0 To 7
r1(x) = UsbIoBuffer(x)
Next x

'Note: limited to 7 characters, leaving r1(7) for Report control
'if r1(7) is encoded in the PC module, its possible to utilise the
'r1(0 to 6) for other uses than the LCD display.

'example. [you could use a Select Case]
If r1(7) = 0 Then
Lcdcmdout LcdClear
Endif

If r1(7) = 1 Then
Lcdcmdout LcdLine2Home
For x = 0 To 6
char1 = r1(x)
Lcdout char1
Next x
Endif

If r1(7) = 2 Then
Lcdcmdout LcdLine2Pos(9)
For x = 0 To 6
char1 = r1(x)
Lcdout char1
Next x
Endif

Return                                            

'Feature Data from PC to PIC, controlled by PC.
'Feature data received is stored in UsbftBuffer array.
usbonftout:

'transfer to local Feature buffer
'else I/O values get corrupted
For x = 0 To 7
f1(x) = UsbFtBuffer(x)
Next x

'Note: limited to 6 characters, leaving f1(6),(7) for Feature PWM control
Lcdcmdout LcdLine2Pos(9)
For x = 0 To 5
char2 = f1(x)
Lcdout char2
Next x

'get the pwm duty for the LED's
PWMduty 1, f1(6)
PWMduty 2, f1(7)

Return                                            

'xfers data PC> PIC> PC
'this are called, by firmware, prior to responding to a PC Report Request
usbonioin:
UsbIoBuffer(0) = r1(0)  '0 thru 7 text or hex
UsbIoBuffer(1) = r1(1)
UsbIoBuffer(2) = r1(2)
UsbIoBuffer(3) = r1(3)
UsbIoBuffer(4) = r1(4)
UsbIoBuffer(5) = r1(5)
UsbIoBuffer(6) = r1(6)
UsbIoBuffer(7) = r1(7)
Return                                            

'xfers data  PC> PIC >PC
'this are called, by firmware, prior to responding to a PC Feature Request
usbonftin:
UsbFtBuffer(0) = f1(0)  '0 thru 5 text or hex
UsbFtBuffer(1) = f1(1)
UsbFtBuffer(2) = f1(2)
UsbFtBuffer(3) = f1(3)
UsbFtBuffer(4) = f1(4)
UsbFtBuffer(5) = f1(5)
UsbFtBuffer(6) = f1(6)  'pwmon1 duty
UsbFtBuffer(7) = f1(7)  'pwmon2 duty
Return                                            

'convert a 16bit binary value to 5 ASCII decimal characters
'name the binary word as binval and call this subr and the ASCII
'result will be in ascbfr4,3,2,1,0, ready for your LCD or UART
'place the DPoint in the output to the LCD [as shown above]
'NOTE: leading Zero's are displayed
bin2asc:
asc1(4) = binval / 10000
temp1 = binval Mod 10000

asc1(3) = temp1 / 1000
temp1 = binval Mod 1000

asc1(2) = temp1 / 100
temp1 = temp1 Mod 100

asc1(1) = temp1 / 10
asc1(0) = temp1 Mod 10
'results are BCD so
'convert to ASCII for LCD
asc1(4) = asc1(4) Or 0x30
asc1(3) = asc1(3) Or 0x30
asc1(2) = asc1(2) Or 0x30
asc1(1) = asc1(1) Or 0x30
asc1(0) = asc1(0) Or 0x30
Return                                            


